export interface QueryParamDefinition {
    /**
     * We use '*' to represent an array, e.g. 'items.*.*.foo = 42' is equivalent to '{items: [[{foo: 42}]]}' (nested array).
     * An empty array technically references the root params object, setting it to a scalar, although in practice the params
     * object is always a complex object.
     */
    jsonPath: string[];
    queryParamName: string;
    rewrites: Record<string, string | undefined>;
    /**
     * A single query parameter can support multiple types.
     */
    type: "string" | "number" | "boolean" | "null";
}
