import { StorageStatisticsSegmentDto } from "../../statistics/storage/dtos/shared/StorageStatisticsSegmentDto";
import { UploadStatisticsDto } from "../../statistics/storage/dtos/shared/UploadStatisticsDto";
import { FileTagName } from "../../common/model/Primitives";
import { NonEmptyArray } from "../../common/model/NonEmptyArray";
import { BasicFileEvent } from "../../statistics/storage/BasicFileEvent";
import { DailyMonthlyBytesDto } from "../../statistics/storage/dtos/shared/DailyMonthlyBytesDto";
import { StorageStatisticsByTimeDto } from "../../statistics/storage/dtos/shared/StorageStatisticsByTimeDto";
import { InvocationEvent } from "../../statistics/storage/InvocationEvent";
import { DailyMonthlyDurationsDto } from "../../statistics/storage/dtos/shared/DailyMonthlyDurationsDto";
import { DailyMonthlyUploadsDto } from "../../statistics/storage/dtos/shared/DailyMonthlyUploadsDto";
export declare class StatisticsCalculator {
    private static readonly dashboardUploadTag;
    static calculateStatistics(newEvents: NonEmptyArray<BasicFileEvent>, sizeMultiplier: 1 | -1 | 0, countMultiplier: 1 | -1 | 0): UploadStatisticsDto;
    static calculateMonthlyDailyBytes(events: BasicFileEvent[]): DailyMonthlyBytesDto;
    static calculateMonthlyDailyUploads(events: BasicFileEvent[]): DailyMonthlyUploadsDto;
    static calculateMonthlyDailyDurations(events: InvocationEvent[]): DailyMonthlyDurationsDto;
    static calculateStatisticsSegment(newEvents: NonEmptyArray<BasicFileEvent>, sizeMultiplier: 1 | -1 | 0, countMultiplier: 1 | -1 | 0): StorageStatisticsSegmentDto;
    static isFileFromDashboard(tags: FileTagName[]): boolean;
    static calculateStorageStatisticsByTime(newEvents: NonEmptyArray<BasicFileEvent>, sizeMultiplier: 1 | -1 | 0, countMultiplier: 1 | -1 | 0): StorageStatisticsByTimeDto;
    private static calculateBytesPerEpochUnit;
    private static calculateUploadsPerEpochUnit;
    private static reducePerEpochUnit;
    private static calculateDurationsPerEpochUnit;
}
