import { BigSizeInBytes } from "@upload-io/upload-shared-iso/common/model/Primitives";
import { BigSizeInBytesUnboxed } from "@upload-io/upload-shared-iso/common/model/UnboxedPrimitives";
import { IsoObjectUtils } from "@upload-io/upload-shared-iso/common/IsoObjectUtils";
import { BoxedArithmetic } from "@upload-io/upload-shared-iso/common/BoxedArithmetic";

// 'epochValue' can be epoch month, epoch day, etc.
export interface BytesByEpochDto {
  [epochValue: string]: BigSizeInBytes | undefined;
}

export interface BytesByEpochUnboxedDto {
  [epochValue: string]: BigSizeInBytesUnboxed | null;
}

export namespace BytesByEpochDto {
  export function combine(left: BytesByEpochDto, right: BytesByEpochDto): BytesByEpochDto {
    return IsoObjectUtils.fullOuterJoin(left, right, BoxedArithmetic.bigSizeInBytes.add);
  }
}
