import {
  StorageStatisticsSegmentDto,
  StorageStatisticsSegmentUnboxedDto
} from "@upload-io/upload-shared-iso/statistics/storage/dtos/shared/StorageStatisticsSegmentDto";
import {
  StorageStatisticsByTimeDto,
  StorageStatisticsByTimeUnboxedDto,
  CreatesAndDeletesByTimeDto
} from "@upload-io/upload-shared-iso/statistics/storage/dtos/shared/StorageStatisticsByTimeDto";

export interface UploadStatisticsDto {
  all: StorageStatisticsSegmentDto;
  byTime: StorageStatisticsByTimeDto;
}

export interface UploadStatisticsUnboxedDto {
  all: StorageStatisticsSegmentUnboxedDto;
  byTime: StorageStatisticsByTimeUnboxedDto;
}

export namespace UploadStatisticsDto {
  export const empty: UploadStatisticsDto = {
    all: StorageStatisticsSegmentDto.empty,
    byTime: CreatesAndDeletesByTimeDto.empty
  };

  export function combine(left: UploadStatisticsDto, right: UploadStatisticsDto): UploadStatisticsDto {
    return {
      all: StorageStatisticsSegmentDto.combine(left.all, right.all),
      byTime: CreatesAndDeletesByTimeDto.combine(left.byTime, right.byTime)
    };
  }
}
